Subject: Re: bug#43395: closed

From: Madhu <[email-masked]>
Date: Sun, 21 Mar 2021 19:40:44 +0530 (IST)

I think this dragon has not been put to sleep yet.  I ran into the
problem again - quite quickly within some 5 hours of emacs uptime

GNU Emacs 28.0.50 (build 1, x86_64-pc-linux-gnu, Motif Version 2.3.8,
cairo version 1.16.0) of 2021-03-08 (master commit a190bc9f3 - with
the motif removal reverted.)

  PID USER      PR  NI    VIRT    RES  %CPU  %MEM     TIME+ S COMMAND
21301 madhu     20   0 2988364   2.7g   0.0  36.7   5:04.01 S emacs

USER       PID %CPU %MEM    VSZ   RSS TTY      STAT START   TIME COMMAND
madhu    21301  1.9 36.7 2988364 2809536 pts/2 Ssl+ 14:06   5:03 /12/build/emacs/build-motif/src/emacs -nw

A full gc does not release the resident memory.

I had an emacs -nw session and one X emacsclient session.  I was
prompted for a passwd by mew in the gui frame, and the prompt appeared
on the tty frame - which was where I entered the password. Then I
noticed the cpu temperature was up, and and a Ctrl-G on emacs stopped
that. I think the leak may have occured then but I didn't notice it
until later. When I did notice it i killed all the buffers did a gc
and ran the memory and malloc reports - which I'm attaching here - in
case it gives any clues.

The emacs command line was:

TERM=xterm-256color MALLOC_ARENA_MAX=2 exec /12/build/emacs/build-motif/src/emacs -nw" > ~/emacs.log 2>&1
Garbage collection stats:
((conses 16 788433 262686) (symbols 48 72449 79) (strings 32 397265 20150) (string-bytes 1 26247796) (vectors 16 88641) (vector-slots 8 1961725 208444) (floats 8 1191 1377) (intervals 56 9514 5343) (buffers 992 8))

 =>	12.0MB (+ 4.01MB dead) in conses
	3.32MB (+ 3.70kB dead) in symbols
	12.1MB (+  630kB dead) in strings
	25.0MB in string-bytes
	1.35MB in vectors
	15.0MB (+ 1.59MB dead) in vector-slots
	9.30kB (+ 10.8kB dead) in floats
	 520kB (+  292kB dead) in intervals
	7.75kB in buffers

Total in lisp objects: 75.9MB (live 69.3MB, dead 6.51MB)

Buffer ralloc memory usage:
8 buffers
16.2kB total (14.0kB in gaps)
      Size	Gap	Name

      1277	753	memory-report.txt
       670	1575	*Buffer Details*
       274	5855	*Ibuffer*
       103	1918	*Messages*
        35	2002	 *Echo Area 0*
         0	2087	 *Minibuf-1*
         0	20	 *Minibuf-0*
         0	20	 *Echo Area 1*
Estimated Emacs Memory Usage

  69.3 MiB  Overall Object Memory Usage
  11.1 MiB  Memory Used By Global Variables
   6.6 MiB  Reserved (But Unused) Object Memory
   5.5 MiB  Memory Used By Symbol Plists
  61.7 KiB  Total Buffer Memory Usage
   1.2 KiB  Total Image Cache Size

Object Storage

  37.2 MiB  Strings
  16.3 MiB  Vectors
  12.0 MiB  Conses
   3.3 MiB  Symbols
 514.2 KiB  Intervals
   9.3 KiB  Floats
   6.8 KiB  Buffer-Objects

Largest Buffers

  31.5 KiB   *Minibuf-1*
  25.1 KiB  *Ibuffer*
   2.1 KiB   *Echo Area 0*
   1.3 KiB  *Memory Report*
   1.2 KiB  *Messages*
   0.3 KiB   *Minibuf-0*
   0.2 KiB   *Echo Area 1*

Largest Variables

   1.4 MiB  load-history
   1.2 MiB  $portage-category-package-names
 951.6 KiB  +lw-manual-data-7-1-0-0+
 574.5 KiB  ivy--all-candidates
 491.4 KiB  command-history
 296.5 KiB  face-new-frame-defaults
 282.5 KiB  help-definition-prefixes
 236.3 KiB  obarray
 143.1 KiB  org-entities
 137.5 KiB  save-place-alist
  92.5 KiB  global-map
  92.5 KiB  widget-global-map
  89.3 KiB  bibtex-biblatex-entry-alist
  84.4 KiB  buffer-name-history
  83.2 KiB  lw::manual-symbols
  82.2 KiB  gnus-summary-mode-map
  80.9 KiB  coding-system-alist
  79.0 KiB  shortdoc--groups
  77.3 KiB  ivy-history
  74.7 KiB  ivy--virtual-buffers

<malloc version="1">
<heap nr="0">
<sizes>
  <size from="17" to="32" total="4992" count="156"/>
  <size from="33" to="48" total="96" count="2"/>
  <size from="49" to="64" total="189824" count="2966"/>
  <size from="65" to="80" total="12640" count="158"/>
  <size from="81" to="96" total="576" count="6"/>
  <size from="97" to="112" total="448" count="4"/>
  <size from="33" to="33" total="8778" count="266"/>
  <size from="49" to="49" total="686" count="14"/>
  <size from="193" to="193" total="6369" count="33"/>
  <size from="209" to="209" total="5225" count="25"/>
  <size from="225" to="225" total="5400" count="24"/>
  <size from="241" to="241" total="241" count="1"/>
  <size from="257" to="257" total="15677" count="61"/>
  <size from="273" to="273" total="6825" count="25"/>
  <size from="289" to="289" total="7225" count="25"/>
  <size from="305" to="305" total="915" count="3"/>
  <size from="321" to="321" total="21507" count="67"/>
  <size from="337" to="337" total="6740" count="20"/>
  <size from="353" to="353" total="3530" count="10"/>
  <size from="369" to="369" total="1845" count="5"/>
  <size from="385" to="385" total="20790" count="54"/>
  <size from="401" to="401" total="4010" count="10"/>
  <size from="417" to="417" total="2085" count="5"/>
  <size from="433" to="433" total="2165" count="5"/>
  <size from="449" to="449" total="16164" count="36"/>
  <size from="465" to="465" total="2325" count="5"/>
  <size from="481" to="481" total="3848" count="8"/>
  <size from="497" to="497" total="1491" count="3"/>
  <size from="513" to="513" total="15903" count="31"/>
  <size from="529" to="529" total="5819" count="11"/>
  <size from="545" to="545" total="4360" count="8"/>
  <size from="561" to="561" total="2805" count="5"/>
  <size from="577" to="577" total="21926" count="38"/>
  <size from="593" to="593" total="4151" count="7"/>
  <size from="609" to="609" total="4263" count="7"/>
  <size from="625" to="625" total="625" count="1"/>
  <size from="641" to="641" total="16666" count="26"/>
  <size from="657" to="657" total="24966" count="38"/>
  <size from="673" to="673" total="4711" count="7"/>
  <size from="689" to="689" total="4134" count="6"/>
  <size from="705" to="705" total="12690" count="18"/>
  <size from="721" to="721" total="8652" count="12"/>
  <size from="737" to="737" total="6633" count="9"/>
  <size from="753" to="753" total="753" count="1"/>
  <size from="769" to="769" total="9228" count="12"/>
  <size from="785" to="785" total="3140" count="4"/>
  <size from="801" to="801" total="4806" count="6"/>
  <size from="817" to="817" total="817" count="1"/>
  <size from="833" to="833" total="4165" count="5"/>
  <size from="849" to="849" total="10188" count="12"/>
  <size from="865" to="865" total="3460" count="4"/>
  <size from="881" to="881" total="2643" count="3"/>
  <size from="897" to="897" total="29601" count="33"/>
  <size from="913" to="913" total="2739" count="3"/>
  <size from="929" to="929" total="1858" count="2"/>
  <size from="945" to="945" total="9450" count="10"/>
  <size from="961" to="961" total="23064" count="24"/>
  <size from="977" to="977" total="18563" count="19"/>
  <size from="993" to="993" total="4965" count="5"/>
  <size from="1009" to="1009" total="94846" count="94"/>
  <size from="1025" to="1073" total="442846" count="430"/>
  <size from="1089" to="1137" total="94742" count="86"/>
  <size from="1153" to="1201" total="32700" count="28"/>
  <size from="1217" to="1249" total="29432" count="24"/>
  <size from="1281" to="1329" total="32617" count="25"/>
  <size from="1345" to="1393" total="20495" count="15"/>
  <size from="1409" to="1457" total="24369" count="17"/>
  <size from="1473" to="1521" total="16459" count="11"/>
  <size from="1537" to="1585" total="20317" count="13"/>
  <size from="1601" to="1649" total="19388" count="12"/>
  <size from="1665" to="1713" total="11783" count="7"/>
  <size from="1729" to="1777" total="8757" count="5"/>
  <size from="1793" to="1841" total="16377" count="9"/>
  <size from="1857" to="1905" total="15016" count="8"/>
  <size from="1921" to="1969" total="33153" count="17"/>
  <size from="1985" to="2033" total="68418" count="34"/>
  <size from="2049" to="2097" total="205492" count="100"/>
  <size from="2113" to="2161" total="89514" count="42"/>
  <size from="2177" to="2225" total="30782" count="14"/>
  <size from="2241" to="2289" total="27068" count="12"/>
  <size from="2305" to="2353" total="34799" count="15"/>
  <size from="2369" to="2417" total="28748" count="12"/>
  <size from="2433" to="2481" total="12277" count="5"/>
  <size from="2497" to="2529" total="17623" count="7"/>
  <size from="2561" to="2609" total="18119" count="7"/>
  <size from="2689" to="2737" total="16230" count="6"/>
  <size from="2753" to="2785" total="19431" count="7"/>
  <size from="2817" to="2865" total="17094" count="6"/>
  <size from="2881" to="2929" total="8723" count="3"/>
  <size from="2945" to="2993" total="29706" count="10"/>
  <size from="3009" to="3057" total="36524" count="12"/>
  <size from="3073" to="3121" total="101665" count="33"/>
  <size from="3137" to="3553" total="293369" count="89"/>
  <size from="3585" to="4081" total="163002" count="42"/>
  <size from="4097" to="4561" total="345522" count="82"/>
  <size from="4641" to="5105" total="166258" count="34"/>
  <size from="5121" to="5617" total="185635" count="35"/>
  <size from="5633" to="6113" total="100273" count="17"/>
  <size from="6145" to="6641" total="170315" count="27"/>
  <size from="6705" to="7153" total="61977" count="9"/>
  <size from="7169" to="7553" total="167719" count="23"/>
  <size from="7777" to="8177" total="95996" count="12"/>
  <size from="8193" to="8673" total="602825" count="73"/>
  <size from="8737" to="9201" total="72424" count="8"/>
  <size from="9217" to="9713" total="437983" count="47"/>
  <size from="9729" to="9985" total="88681" count="9"/>
  <size from="11473" to="11473" total="11473" count="1"/>
  <size from="13201" to="16369" total="1057223" count="71"/>
  <size from="16401" to="20321" total="2678684" count="156"/>
  <size from="20497" to="24513" total="617340" count="28"/>
  <size from="24657" to="28433" total="479890" count="18"/>
  <size from="28929" to="32529" total="368252" count="12"/>
  <size from="32801" to="36833" total="480238" count="14"/>
  <size from="37089" to="40241" total="196741" count="5"/>
  <size from="42017" to="65249" total="1370090" count="26"/>
  <size from="65649" to="92913" total="1487091" count="19"/>
  <size from="101089" to="115713" total="440132" count="4"/>
  <size from="141361" to="157793" total="299154" count="2"/>
  <size from="163889" to="230721" total="1753993" count="9"/>
  <size from="324161" to="468993" total="2808135" count="7"/>
  <size from="545265" to="1799181393" total="2731856606" count="30"/>
  <unsorted from="129" to="16929" total="163118" count="30"/>
</sizes>
<total type="fast" count="3292" size="208576"/>
<total type="rest" count="3139" size="2751257554"/>
<system type="current" size="2856476672"/>
<system type="max" size="2856476672"/>
<aspace type="total" size="2856476672"/>
<aspace type="mprotect" size="2856476672"/>
</heap>
<heap nr="1">
<sizes>
  <size from="17" to="32" total="992" count="31"/>
  <size from="33" to="48" total="240" count="5"/>
  <size from="97" to="112" total="112" count="1"/>
</sizes>
<total type="fast" count="37" size="1344"/>
<total type="rest" count="1" size="96656"/>
<system type="current" size="135168"/>
<system type="max" size="135168"/>
<aspace type="total" size="135168"/>
<aspace type="mprotect" size="135168"/>
<aspace type="subheaps" size="1"/>
</heap>
<total type="fast" count="3329" size="209920"/>
<total type="rest" count="3140" size="2751354210"/>
<total type="mmap" count="2" size="692224"/>
<system type="current" size="2856611840"/>
<system type="max" size="2856611840"/>
<aspace type="total" size="2856611840"/>
<aspace type="mprotect" size="2856611840"/>
</malloc>